package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CoursePhotoLogAddBo;
import com.zhongzheng.modules.course.bo.CoursePhotoLogEditBo;
import com.zhongzheng.modules.course.bo.CoursePhotoLogQueryBo;
import com.zhongzheng.modules.course.domain.CoursePhotoLog;
import com.zhongzheng.modules.course.mapper.CoursePhotoLogMapper;
import com.zhongzheng.modules.course.service.ICoursePhotoLogService;
import com.zhongzheng.modules.course.vo.CoursePhotoLogVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户节拍照记录Service业务层处理
 *
 * @author hjl
 * @date 2022-01-12
 */
@Service
public class CoursePhotoLogServiceImpl extends ServiceImpl<CoursePhotoLogMapper, CoursePhotoLog> implements ICoursePhotoLogService {

    @Override
    public CoursePhotoLogVo queryById(Long id){
        CoursePhotoLog db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, CoursePhotoLogVo.class);
    }

    @Override
    public List<CoursePhotoLogVo> queryList(CoursePhotoLogQueryBo bo) {
        LambdaQueryWrapper<CoursePhotoLog> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getSectionId() != null, CoursePhotoLog::getSectionId, bo.getSectionId());
        lqw.eq(StrUtil.isNotBlank(bo.getPhoto()), CoursePhotoLog::getPhoto, bo.getPhoto());
        lqw.eq(bo.getPhotoTime() != null, CoursePhotoLog::getPhotoTime, bo.getPhotoTime());
        lqw.eq(bo.getUserId() != null, CoursePhotoLog::getUserId, bo.getUserId());
        lqw.eq(bo.getPhotoNum() != null, CoursePhotoLog::getPhotoNum, bo.getPhotoNum());
        lqw.eq(bo.getStatus() != null, CoursePhotoLog::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CoursePhotoLogVo> entity2Vo(Collection<CoursePhotoLog> collection) {
        List<CoursePhotoLogVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CoursePhotoLogVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CoursePhotoLog> page = (Page<CoursePhotoLog>)collection;
            Page<CoursePhotoLogVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CoursePhotoLogAddBo bo) {
        CoursePhotoLog add = BeanUtil.toBean(bo, CoursePhotoLog.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public List<CoursePhotoLogVo> getLastInfo(CoursePhotoLogQueryBo bo) {
        return this.baseMapper.getLastInfo(bo);
    }

    @Override
    public Boolean updateByEditBo(CoursePhotoLogEditBo bo) {
        CoursePhotoLog update = BeanUtil.toBean(bo, CoursePhotoLog.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CoursePhotoLog entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
